{% set thead_attributes = {} %}
{% set tbody_attributes = {} %}
{% set tfoot_attributes = {} %}
{% set header_length = header|length if header else 0 %}
{% set header_columns = header_columns|default(header_length) %}
{% set attributes = attributes|add_class("usa-table") %}
{% if sticky %}
  {% set attributes = attributes|add_class("usa-table--sticky-header") %}
{% endif %}
{% if striped %}
  {% set attributes = attributes|add_class("usa-table--striped") %}
{% endif %}
{% if borderless %}
  {% set attributes = attributes|add_class("usa-table--borderless") %}
{% endif %}
{% if stacked %}
  {% set attributes = attributes|add_class("usa-table--stacked") %}
{% endif %}
{% if stacked_header %}
  {% set attributes = attributes|add_class("usa-table--stacked-header") %}
{% endif %}
{% if sortable %}
  {% set attributes = attributes|add_class("usa-table--sortable") %}
{% endif %}
{% if compact %}
  {% set attributes = attributes|add_class("usa-table--compact") %}
{% endif %}
{% if scrollable %}<div class="usa-table-container--scrollable" tabindex="0">{% endif %}
  <table {{ attributes }}>
    {% if caption %}<caption>{{ caption }}</caption>{% endif %}
    {% for colgroup in colgroups %}
      {% if colgroup.cols %}
        <colgroup {{ colgroup.attributes }}>
          {% for col in colgroup.cols %}<col {{ col.attributes }} />{% endfor %}
        </colgroup>
      {% else %}
        <colgroup {{ colgroup.attributes }} />
      {% endif %}
    {% endfor %}
    {% if header %}
      <thead {{ thead_attributes }}>
        <tr>
          {% for cell in header %}
            {% if sortable %}
              <{{ cell.tag|default("th") }}{{ cell.attributes|default({}) |set_attribute("data-sortable", "true")|set_attribute("scope", "col") }}>
            {% else %}
              <{{ cell.tag|default("th") }}{{ cell.attributes|default({}) |set_attribute("scope", "col") }}>
            {% endif %}
            {{ cell.content }}</{{ cell.tag|default("th") }}>
          {% endfor %}
        </tr>
      </thead>
    {% endif %}
    {% if rows %}
      <tbody {{ tbody_attributes }}>
        {% for row in rows %}
          <tr {{ row.attributes }}>
            {% for cell in row.cells %}
              <{{ cell.tag|default("th") }}{{ cell.attributes|default({}) |set_attribute("scope", "row") }}>{{ cell.content }}</{{ cell.tag|default("td") }}>
            {% endfor %}
          </tr>
        {% endfor %}
      </tbody>
    {% elif empty %}
      <tbody {{ tbody_attributes }}>
        <tr>
          <td colspan="{{ header_columns }}">{{ empty }}</td>
        </tr>
      </tbody>
    {% endif %}
    {% if footer %}
      <tfoot {{ tfoot_attributes }}>
        {% for row in footer %}
          <tr {{ row.attributes }}>
            {% for cell in row.cells %}
              <{{ cell.tag|default("td") }}{{ cell.attributes }}>{{ cell.content }}</{{ cell.tag|default("td") }}>
            {% endfor %}
          </tr>
        {% endfor %}
      </tfoot>
    {% endif %}
  </table>
  {% if sortable %}<div class="usa-sr-only usa-table__announcement-region" aria-live="polite"></div>{% endif %}
  {% if scrollable %}</div>{% endif %}
